import LarkAuthService from "./auth"
import LarkChatService from "./chat"
import LarkDriveService from "./drive"
import LarkMessageService from "./message"
import LarkSheetService from "./sheet"
import LarkUserService from "./user"

class LarkService {
  drive: LarkDriveService
  message: LarkMessageService
  user: LarkUserService
  sheet: LarkSheetService
  auth: LarkAuthService
  chat: LarkChatService
  requestId: string

  constructor({
    appId,
    appSecret,
    requestId,
  }: {
    appId?: string
    appSecret?: string
    requestId: string
  }) {
    this.auth = new LarkAuthService({
      appId,
      appSecret,
      requestId,
    })
    const getAppAuth = () => this.auth.getAppAuth()
    this.drive = new LarkDriveService(getAppAuth, requestId)
    this.message = new LarkMessageService(getAppAuth, requestId)
    this.user = new LarkUserService(getAppAuth, requestId)
    this.sheet = new LarkSheetService(getAppAuth, requestId)
    this.chat = new LarkChatService(getAppAuth, requestId)
    this.requestId = requestId
  }
}

export default LarkService
